// C Source File
// Created 7/21/2002; 1:26:36 PM
#include "edit_globals.h"
#include <tigcclib.h>
#include "extgraph.h"
#ifndef TileDataStuff
#define TileDataStuff
// number of tiles in array data
#define TILENUMBER_DATA 8

// height of one tile in array data
#define TILEHEIGHT_DATA 16

// macro returns the address of tile nr of plane p from array data
#define GFXTILE(p,nr) &(data[p][TILEHEIGHT_DATA*nr])
#endif

#define _findme(a,b) (map_width*(b) + (a))
void
draw_edit_balls (void)
{

  short x, y;
  short x2, y2;
  char vidmemcur = 0;

  ClearGrayScreen2B (screen0, screen1);

  for (y = 0; y < ymax; y++)
    {
      for (x = 0; x < xmax; x++)
	{
	  x2 = x + screen_x;
	  y2 = y + screen_y;
	  vidmemcur = vidmem[_findme (x2, y2)];
	  if (vidmemcur == 0 || vidmemcur > TILENUMBER_DATA)
	    continue;
	  //vidmemcur--;
	  vidmemcur += 4;
	  GraySprite16_OR (x * 16, y * 16, 16, GFXTILE (0, vidmemcur),
			   GFXTILE (1, vidmemcur), screen0, screen1);
	}
    }

}
