// C Header File
// Created 8/24/2002; 12:45:59 PM

void
GenerateRespawnPointsFromMap (FATCONFIG * fc)
{
  short x;
  short y;
  short count = 0;
  short check = 0;
  randomize ();
  switch (gamedata.gametype)
    {
    case DM...TEAM:
      for (check = 0; check < fc->map_width * fc->map_height; check++)
	{
	  if (fc->map_data[check] <= 0 && fc->map_data[check] >= GRAY_FLAG)
	    count++;
	}
      if (count < (MAX_PLAYERS + 1) * 2)
	{
	  gamedata.quitting = E2Q (ARENA_MAP_FILE_ERROR);
	  return;
	}
      break;
    case CTF:
      for (check = 0; check < fc->map_width * fc->map_height; check++)
	{
	  if (fc->map_data[check] == WHITE_AREA)
	    count++;
	}
      if (count < (MAX_PLAYERS + 1) * 2)
	{
	  gamedata.quitting = -3;
	  return;
	}
      count = 0;
      for (check = 0; check < fc->map_width * fc->map_height; check++)
	{
	  if (fc->map_data[check] == GRAY_AREA)
	    count++;
	}
      if (count < (MAX_PLAYERS + 1) * 2)
	{
	  gamedata.quitting = -3;
	  return;
	}
      count = 0;
      for (check = 0; check < fc->map_width * fc->map_height; check++)
	{
	  if (fc->map_data[check] == WHITE_FLAG)
	    {
	      count++;
	      break;
	    }
	}
      if (!count)
	{
	  gamedata.quitting = -3;
	  return;
	}
      count = 0;
      for (check = 0; check < fc->map_width * fc->map_height; check++)
	{
	  if (fc->map_data[check] == GRAY_FLAG)
	    {
	      count++;
	      break;
	    }
	}
      if (!count)
	{
	  gamedata.quitting = -3;
	  return;
	}
      break;
    }

  count = 0;
  while (count < (MAX_PLAYERS + 1) * 2)
    {
      x = random (fc->map_width);
      y = random (fc->map_height);
      switch (gamedata.gametype)
	{
	case DM...TEAM:
	  if (fc->map_data[y * fc->map_width + x] <= 0 && fc->map_data[y * fc->map_width + x]>= GRAY_FLAG)
	    {
	      respawns[count].x = x;
	      respawns[count].y = y;
	      count++;
	    }
	  break;
	case CTF:
	  if (count % 2)	//white
	    {
	      if (fc->map_data[y * fc->map_width + x] == WHITE_AREA)
		{
		  respawns[count].x = x;
		  respawns[count].y = y;
		  count++;
		}
	    }
	  else			//gray
	    {
	      if (fc->map_data[y * fc->map_width + x] == GRAY_AREA)
		{
		  respawns[count].x = x;
		  respawns[count].y = y;
		  count++;
		}
	    }
	  break;
	}
    }

}

void
SpawnCTFflagsFromMap (FATCONFIG * fc)
{
  short x, y;
  for (x = 0; x < fc->map_width; x++)
    {
      for (y = 0; y < fc->map_height; y++)
	{
	  if (fc->map_data[y * fc->map_width + x] == GRAY_FLAG)
	    {
	      gamedata.flag[GRAY_TEAM].spr->xpos = x * 64 + 32;
	      gamedata.flag[GRAY_TEAM].spr->ypos = y * 64 + 32;
	      gamedata.flag[GRAY_TEAM].base_x =
		gamedata.flag[GRAY_TEAM].spr->xpos;
	      gamedata.flag[GRAY_TEAM].base_y =
		gamedata.flag[GRAY_TEAM].spr->ypos;
	      gamedata.flag[GRAY_TEAM].spr->drawmode = SPRITEMODE_SIZE64;
	      gamedata.flag[GRAY_TEAM].spr->nr_textures = 1;
	      gamedata.flag[GRAY_TEAM].spr->textures =
		model_tex + SPRIDX_flag_g;
	    }
	  else if (fc->map_data[y * fc->map_width + x] == WHITE_FLAG)
	    {
	      gamedata.flag[WHITE_TEAM].spr->xpos = x * 64 + 32;
	      gamedata.flag[WHITE_TEAM].spr->ypos = y * 64 + 32;
	      gamedata.flag[WHITE_TEAM].base_x =
		gamedata.flag[WHITE_TEAM].spr->xpos;
	      gamedata.flag[WHITE_TEAM].base_y =
		gamedata.flag[WHITE_TEAM].spr->ypos;
	      gamedata.flag[WHITE_TEAM].spr->drawmode = SPRITEMODE_SIZE64;
	      gamedata.flag[WHITE_TEAM].spr->nr_textures = 1;
	      gamedata.flag[WHITE_TEAM].spr->textures =
		model_tex + SPRIDX_flag_w;
	    }
	}
    }
}
